/*
//        C-51 Demo program for CEIBO 51 Debugger
//             Copyright (c) 1994,9 by CEIBO
//
//        Program compiled with KEIL C-51 compiler
//        Compiler command line : (For Emulator test files: ctest.abs)
//           C51 ctest.c ROM(SMALL) DEBUG OBJECTEXTEND NOAMAKE DF(EMULATOR)
//        Linker command line :
//           L51 ctest.obj,cinit.obj,cdelay.obj TO ctest.abs CODE(100h)
//
//        Compiler command line : (For Simulator test files: ctests.abs)
//           C51 ctest.c ROM(SMALL) DEBUG OBJECTEXTEND NOAMAKE DF(SIMULATOR)
//        Linker command line :
//           L51 ctest.obj,cinit.obj,cdelay.obj TO ctests.abs CODE(100h)
//
*/

/*
//     Global variables definition
*/
unsigned int     DelayCnt;
unsigned int     DelayValue;
unsigned char    PatternROL;
unsigned char    PatternROR;
unsigned char    PatternCPL;

sfr RegM1 = 0x84;
sfr RegM2 = 0x85;
sfr RegPort = 0x80;


/*
//    External functions declaration
*/
extern void init();
extern void Delay();


/*
//           Function : RolPort
//           ==================
//           Rotate left Port  - RotNo times
//
//           Function parameter
//           ==================
//              RotNo - number of times to rotate port
*/
void RolPort(unsigned char RotNo)
{
  unsigned char RotCnt;
  for ( RotCnt = 1; RotCnt <= RotNo; RotCnt++ )
  {
     Delay();
     if (( RegPort & 0x80 ) == 0x80 )
       RegPort = (RegPort << 1) | 1;
     else
       RegPort = (RegPort << 1);
  }
}

/*
//           Function : ROrPort
//           ==================
//           Rotate right Port - RotNo times
//
//           Function parameter :
//              ROtNo - number of times to rotate port
*/
void RorPort(unsigned char RotNo)
{
  unsigned char RotCnt;
  for ( RotCnt = 1; RotCnt <= RotNo; RotCnt++ )
  {
     Delay();
     if (( RegPort & 0x01 ) == 0x01 )
       RegPort = (RegPort >> 1) | 0x80;
     else
       RegPort = (RegPort >> 1);
  }
}

/*
//           Function : CplPort
//           ==================
//           Complement Port - CplNo times
//
//           Function parameter
//              CplNo - number of times to complement port
*/
void CplPort(unsigned char CplNo)
{
  unsigned char CplCnt;
  for ( CplCnt = 1; CplCnt <= CplNo; CplCnt++ )
  {
     Delay();
     RegPort = ~RegPort;
  }
}

/*
//           Function : main
//           ==================
//           Main block of program
*/
void main()
{
  init();
  while ( 1 )
  {
    Delay();
    RegPort = PatternCPL;
    CplPort(8);
    Delay();
    RegPort = PatternROR;
    RorPort(7);
    Delay();
    RegPort = PatternROR;
    RorPort(7);
    Delay();
    RegPort = PatternROL;
    RolPort(7);
    Delay();
    RegPort = PatternROL;
    RolPort(7);
    Delay();
  }
}
